/*!
 * Fuse.js v3.4.1 - Lightweight fuzzy-search (http://fusejs.io)
 * 
 * Copyright (c) 2012-2017 Kirollos Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define("Fuse",[],t):"object"==typeof exports?exports.Fuse=t():e.Fuse=t()}(this,function(){var e=Math.min;return function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,t),o.l=!0,o.exports}var n={};return t.m=e,t.c=n,t.d=function(e,n,r){t.o(e,n)||Object.defineProperty(e,n,{enumerable:!0,get:r})},t.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},t.t=function(e,n){if(1&n&&(e=t(e)),8&n)return e;if(4&n&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(t.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&n&&"string"!=typeof e)for(var o in e)t.d(r,o,function(t){return e[t]}.bind(null,o));return r},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=1)}([function(e){e.exports=(e=>Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e))},function(t,n,r){const o=r(2),s=r(8),i=r(0);t.exports=class{constructor(e,{location:t=0,distance:n=100,threshold:r=.6,maxPatternLength:o=32,caseSensitive:i=!1,tokenSeparator:l=/ +/g,findAllMatches:a=!1,minMatchCharLength:c=1,id:h=null,keys:u=[],shouldSort:p=!0,getFn:f=s,sortFn:d=((e,t)=>e.score-t.score),tokenize:g=!1,matchAllTokens:y=!1,includeMatches:m=!1,includeScore:x=!1,verbose:S=!1}){this.options={location:t,distance:n,threshold:r,maxPatternLength:o,isCaseSensitive:i,tokenSeparator:l,findAllMatches:a,minMatchCharLength:c,id:h,keys:u,includeMatches:m,includeScore:x,shouldSort:p,getFn:f,sortFn:d,verbose:S,tokenize:g,matchAllTokens:y},this.setCollection(e)}setCollection(e){return this.list=e,e}search(e,t={limit:!1}){this._log(`---------\nSearch pattern: "${e}"`);const{tokenSearchers:n,fullSearcher:r}=this._prepareSearchers(e);let{weights:o,results:s}=this._search(n,r);return this._computeScore(o,s),this.options.shouldSort&&this._sort(s),t.limit&&"number"==typeof t.limit&&(s=s.slice(0,t.limit)),this._format(s)}_prepareSearchers(e=""){const t=[];if(this.options.tokenize){const n=e.split(this.options.tokenSeparator);for(let e=0,r=n.length;e<r;e+=1)t.push(new o(n[e],this.options))}return{tokenSearchers:t,fullSearcher:new o(e,this.options)}}_search(e=[],t){const n=this.list,r={},o=[];if("string"==typeof n[0]){for(let s=0,i=n.length;s<i;s+=1)this._analyze({key:"",value:n[s],record:s,index:s},{resultMap:r,results:o,tokenSearchers:e,fullSearcher:t});return{weights:null,results:o}}const s={};for(let i,l=0,a=n.length;l<a;l+=1){i=n[l];for(let n,a=0,c=this.options.keys.length;a<c;a+=1){if("string"!=typeof(n=this.options.keys[a])){if(s[n.name]={weight:1-n.weight||1},0>=n.weight||1<n.weight)throw new Error("Key weight has to be > 0 and <= 1");n=n.name}else s[n]={weight:1};this._analyze({key:n,value:this.options.getFn(i,n),record:i,index:l},{resultMap:r,results:o,tokenSearchers:e,fullSearcher:t})}}return{weights:s,results:o}}_analyze({key:e,arrayIndex:t=-1,value:n,record:r,index:o},{tokenSearchers:s=[],fullSearcher:l=[],resultMap:a={},results:c=[]}){if(null==n)return;let h=!1,u=-1,p=0;if("string"==typeof n){this._log(`\nKey: ${""===e?"-":e}`);let i=l.search(n);if(this._log(`Full text: "${n}", score: ${i.score}`),this.options.tokenize){let e=n.split(this.options.tokenSeparator),t=[];for(let n,r=0;r<s.length;r+=1){n=s[r],this._log(`\nPattern: "${n.pattern}"`);let o=!1;for(let r=0;r<e.length;r+=1){let s=e[r],i=n.search(s),l={};i.isMatch?(l[s]=i.score,h=!0,o=!0,t.push(i.score)):(l[s]=1,!this.options.matchAllTokens&&t.push(1)),this._log(`Token: "${s}", score: ${l[s]}`)}o&&(p+=1)}u=t[0];let r=t.length;for(let e=1;e<r;e+=1)u+=t[e];u/=r,this._log("Token score average:",u)}let f=i.score;-1<u&&(f=(f+u)/2),this._log("Score average:",f);let d=!(this.options.tokenize&&this.options.matchAllTokens)||p>=s.length;if(this._log(`\nCheck Matches: ${d}`),(h||i.isMatch)&&d){let s=a[o];s?s.output.push({key:e,arrayIndex:t,value:n,score:f,matchedIndices:i.matchedIndices}):(a[o]={item:r,output:[{key:e,arrayIndex:t,value:n,score:f,matchedIndices:i.matchedIndices}]},c.push(a[o]))}}else if(i(n))for(let t=0,i=n.length;t<i;t+=1)this._analyze({key:e,arrayIndex:t,value:n[t],record:r,index:o},{resultMap:a,results:c,tokenSearchers:s,fullSearcher:l})}_computeScore(t,n){this._log("\n\nComputing score:\n");for(let r=0,o=n.length;r<o;r+=1){const o=n[r].output,s=o.length;let i=1,l=1;for(let n=0;n<s;n+=1){let r=t?t[o[n].key].weight:1,s=(1===r?o[n].score:o[n].score||.001)*r;1===r?(o[n].nScore=s,i*=s):l=e(l,s)}n[r].score=1===l?i:l,this._log(n[r])}}_sort(e){this._log("\n\nSorting...."),e.sort(this.options.sortFn)}_format(e){const t=[];if(this.options.verbose){let t=[];this._log("\n\nOutput:\n\n",JSON.stringify(e,function(e,n){if("object"==typeof n&&null!==n){if(-1!==t.indexOf(n))return;t.push(n)}return n})),t=null}let n=[];this.options.includeMatches&&n.push((e,t)=>{const n=e.output;t.matches=[];for(let e,r=0,o=n.length;r<o;r+=1){if(0===(e=n[r]).matchedIndices.length)continue;let o={indices:e.matchedIndices,value:e.value};e.key&&(o.key=e.key),e.hasOwnProperty("arrayIndex")&&-1<e.arrayIndex&&(o.arrayIndex=e.arrayIndex),t.matches.push(o)}}),this.options.includeScore&&n.push((e,t)=>{t.score=e.score});for(let r=0,o=e.length;r<o;r+=1){const o=e[r];if(this.options.id&&(o.item=this.options.getFn(o.item,this.options.id)[0]),!n.length){t.push(o.item);continue}const s={item:o.item};for(let e=0,t=n.length;e<t;e+=1)n[e](o,s);t.push(s)}return t}_log(){this.options.verbose&&console.log(...arguments)}}},function(e,t,n){const r=n(3),o=n(4),s=n(7);e.exports=class{constructor(e,{location:t=0,distance:n=100,threshold:r=.6,maxPatternLength:o=32,isCaseSensitive:i=!1,tokenSeparator:l=/ +/g,findAllMatches:a=!1,minMatchCharLength:c=1}){this.options={location:t,distance:n,threshold:r,maxPatternLength:o,isCaseSensitive:i,tokenSeparator:l,findAllMatches:a,minMatchCharLength:c},this.pattern=this.options.isCaseSensitive?e:e.toLowerCase(),this.pattern.length<=o&&(this.patternAlphabet=s(this.pattern))}search(e){if(this.options.isCaseSensitive||(e=e.toLowerCase()),this.pattern===e)return{isMatch:!0,score:0,matchedIndices:[[0,e.length-1]]};const{maxPatternLength:t,tokenSeparator:n}=this.options;if(this.pattern.length>t)return r(e,this.pattern,n);const{location:s,distance:i,threshold:l,findAllMatches:a,minMatchCharLength:c}=this.options;return o(e,this.pattern,this.patternAlphabet,{location:s,distance:i,threshold:l,findAllMatches:a,minMatchCharLength:c})}}},function(e){const t=/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g;e.exports=((e,n,r=/ +/g)=>{let o=new RegExp(n.replace(t,"\\$&").replace(r,"|")),s=e.match(o),i=!!s,l=[];if(i)for(let t,n=0,r=s.length;n<r;n+=1)t=s[n],l.push([e.indexOf(t),t.length-1]);return{score:i?.5:1,isMatch:i,matchedIndices:l}})},function(t,n,r){const o=r(5),s=r(6);t.exports=((t,n,r,{location:i=0,distance:l=100,threshold:a=.6,findAllMatches:c=!1,minMatchCharLength:h=1})=>{var u=Math.max;const p=i,f=t.length;let d=a,g=t.indexOf(n,p);const y=n.length,m=[];for(let e=0;e<f;e+=1)m[e]=0;if(-1!==g){let r=o(n,{errors:0,currentLocation:g,expectedLocation:p,distance:l});if(d=e(r,d),-1!==(g=t.lastIndexOf(n,p+y))){let t=o(n,{errors:0,currentLocation:g,expectedLocation:p,distance:l});d=e(t,d)}}g=-1;let x=[],S=1,k=y+f;for(let s=0;s<y;s+=1){let i=0,a=k;for(;i<a;){o(n,{errors:s,currentLocation:p+a,expectedLocation:p,distance:l})<=d?i=a:k=a,a=Math.floor((k-i)/2+i)}k=a;let h=u(1,p-a+1),M=c?f:e(p+a,f)+y,_=Array(M+2);_[M+1]=(1<<s)-1;for(let e=M;e>=h;e-=1){let i=e-1,a=r[t.charAt(i)];if(a&&(m[i]=1),_[e]=(1|_[e+1]<<1)&a,0!=s&&(_[e]|=1|(x[e+1]|x[e])<<1|x[e+1]),_[e]&1<<y-1&&(S=o(n,{errors:s,currentLocation:i,expectedLocation:p,distance:l}))<=d){if(d=S,(g=i)<=p)break;h=u(1,2*p-g)}}if(o(n,{errors:s+1,currentLocation:p,expectedLocation:p,distance:l})>d)break;x=_}return{isMatch:0<=g,score:0===S?.001:S,matchedIndices:s(m,h)}})},function(e){e.exports=((e,{errors:t=0,currentLocation:n=0,expectedLocation:r=0,distance:o=100})=>{const s=t/e.length,i=Math.abs(r-n);return o?s+i/o:i?1:s})},function(e){e.exports=((e=[],t=1)=>{let n=[],r=-1,o=-1,s=0;for(let i,l=e.length;s<l;s+=1)(i=e[s])&&-1==r?r=s:!i&&-1!=r&&((o=s-1)-r+1>=t&&n.push([r,o]),r=-1);return e[s-1]&&s-r>=t&&n.push([r,s-1]),n})},function(e){e.exports=(e=>{let t={},n=e.length;for(let r=0;r<n;r+=1)t[e.charAt(r)]=0;for(let r=0;r<n;r+=1)t[e.charAt(r)]|=1<<n-r-1;return t})},function(e,t,n){const r=n(0),o=(e,t,n)=>{if(t){const s=t.indexOf(".");let i=t,l=null;-1!==s&&(i=t.slice(0,s),l=t.slice(s+1));const a=e[i];if(null!=a)if(l||"string"!=typeof a&&"number"!=typeof a)if(r(a))for(let e=0,t=a.length;e<t;e+=1)o(a[e],l,n);else l&&o(a,l,n);else n.push(a.toString())}else n.push(e);return n};e.exports=((e,t)=>o(e,t,[]))}])});